image: node:12-buster
stages:
  - test
  - deploy

test:
  stage: test
  script:
    - npm install -g yaml-lint
    - for f in $(find ./src/ -name "*.yml" -type f);do echo $f; yamllint $f;done;

pages:
  stage: deploy
  script:
  - npm run commons
  - npm run prod
  - rm -r public/ && mv -f dist/$(echo $CI_PAGES_URL | cut -d/ -f4-)/ public/
  - find public -type f -iregex '.*\.\(htm\|html\|txt\|text\|js\|css\)$' -execdir gzip -f --keep {} \;
  artifacts:
    paths:
    - public
  cache:
    paths:
      - node_modules/
  only:
    refs:
    - main
    - master
  except:
    variables:
    - $DEPLOYMENT_KEY
    - $DEPLOYMENT_USER
    - $DEPLOYMENT_HOST

production:
  stage: deploy
#  before_script:
#  - apt-get update
#  - apt-get --yes --force-yes install rsync
  script:
  - npm run commons
  - npm run prod -- --base=abc
  - rm -r public/ && mv dist/ public/
  - cp ./public/abc/fr/index.html ./public/abc/index.html
  - cd public/abc && for f in $(find -type l);do cp --remove-destination $(readlink -f $f) $f;done;
  - eval `ssh-agent -s`
  - ssh-add <(echo "${DEPLOYMENT_KEY}" | base64 --decode -i);
  - echo "put -r ." | sftp -o "VerifyHostKeyDNS yes" -o "StrictHostKeyChecking accept-new" ${DEPLOYMENT_USER}@${DEPLOYMENT_HOST}:../../web/abc/;
#  - rsync -a --rsh='ssh -o "VerifyHostKeyDNS yes" -o "StrictHostKeyChecking accept-new"' --delete . ${DEPLOYMENT_USER}@${DEPLOYMENT_HOST}:../../web/abc/;
  only:
    refs:
    - main
    - master
    variables:
    - $DEPLOYMENT_KEY
    - $DEPLOYMENT_USER
    - $DEPLOYMENT_HOST
